; GUI #
include win64a.inc
; OpenGl Examples->fog
; --------------- 
WINDOWWIDTH	= 440
WINDOWHEIGHT	= 400
.code
WinMain	proc
local	msg:MSG

	xor	ebx,ebx
        mov	edi,offset szClassName
        mov	esi,IMAGE_BASE
        mov	ecx,offset FileName
	invoke	LoadCursorFromFile
        push	rax	;hIconSm
	push	rdi	;lpszClassName
	push	rbx	;lpszMenuName
	push	COLOR_WINDOWTEXT+1;hbrBackground
	push	rax	;hCursor
	push	rax        ;hIcon
	push	rsi	;hInstance
	push	rbx        ;cbClsExtra & cbWndExtra
	pushaddr WndProc;lpfnWndProc
	mov	rax,(CS_HREDRAW or CS_VREDRAW or CS_OWNDC) shl 32 + (sizeof WNDCLASSEX)
	push	rax                     ;cbSize & style
    	invoke	RegisterClassEx,esp	;addr WNDCLASSEX
	
	push	rbx
	push	rsi	;rsi = 400000h
	shl	esi,9	;rsi = CW_USEDEFAULT
	push	rbx
	push	rbx
	push	WINDOWHEIGHT
	push	WINDOWWIDTH
	push	rsi
	push	rsi
	sub	esp,20h
    	invoke	CreateWindowEx,0,edi,edi,WS_OVERLAPPEDWINDOW or WS_CLIPCHILDREN or WS_CLIPSIBLINGS or WS_VISIBLE
; 
    	lea	edi,msg
@@:	invoke	GetMessage,edi,0,0,0
	cmp	msg.wParam,VK_ESCAPE;user press 'Esc'?
	je	wmDESTROY
	invoke	DispatchMessage,edi
	jmp	@b
WinMain endp
WndProc	proc	hWin:QWORD,uMsg:QWORD,wParam:QWORD,lParam:QWORD

        mov	hWin,rcx
	xor	ebx,ebx

        cmp	edx,WM_CREATE
	je      wmCREATE
        cmp	edx,WM_SIZE
	je      wmSIZE
        cmp	edx,WM_PAINT
	je      wmPAINT
        cmp	edx,WM_DESTROY
	je      wmDESTROY     
default:leave
	jmp	NtdllDefWindowProc_
wmDESTROY::invoke wglMakeCurrent,0,0
	invoke	wglDeleteContext,hrc
	invoke	ReleaseDC,hWin,hDC
;	invoke	KillTimer,hWin,10
	invoke	RtlExitUserProcess,NULL
wmCREATE:invoke	GetDC    ;  
	mov	hDC,rax
;    OpenGL ( OpenGL   
;)  
        mov	edx,offset PixFrm
	invoke	ChoosePixelFormat,eax;eax=hDC
;  
	mov	r8d,offset PixFrm
	invoke	SetPixelFormat,hDC,eax
;     OpenGL
	invoke	wglCreateContext,hDC
	mov	hrc,rax
;   
	invoke	wglMakeCurrent,hDC,eax
;---------------------------------------------------
;     ()
	invoke glHint,GL_PERSPECTIVE_CORRECTION_HINT,GL_NICEST;
;     
	invoke glMatrixMode,GL_PROJECTION;     ()
;    , ..    (  glcall ..     8 )
	movq	xmm0,constd90_0
	movq	xmm1,ratio
	movq	xmm2,constd0_1
	movq	xmm3,constd100_0
	invoke	gluPerspective
;    
	invoke	glMatrixMode,GL_MODELVIEW;     ()
;---------------------------------------------------
	invoke	glEnable,GL_DEPTH_TEST

	invoke	glEnable,GL_COLOR_MATERIAL
; 
	invoke	glEnable,GL_LIGHTING
; 3- 
	invoke	glEnable,GL_LIGHT3
; 5- 
	invoke	glEnable,GL_LIGHT5
; 6- 
	invoke	glEnable,GL_LIGHT6

;GL_SPECULAR   
    	mov	r8d,offset sp_
	invoke	glLightfv,GL_LIGHT3,GL_SPECULAR
    	mov	r8d,offset sp_
	invoke	glLightfv,GL_LIGHT5,GL_SPECULAR
    	mov	r8d,offset sp_
	invoke	glLightfv,GL_LIGHT6, GL_SPECULAR
;GL_DIFFUSE -    
    	mov	color[1*4],ebx
	mov	color[2*4],ebx
;color(1,0,0)   
	mov	r8d,offset color
	invoke	glLightfv,GL_LIGHT3, GL_DIFFUSE

	mov	color[0*4],ebx
	mov	eax,const1_0
	mov	color[1*4],eax
;color(0,1,0)   
	mov	r8d,offset color
	invoke	glLightfv,GL_LIGHT5, GL_DIFFUSE
;color(0,0,1)   
    	mov	color[1*4],ebx
	mov	eax,const1_0
	mov	color[2*4],eax
	mov	r8d,offset color
	invoke	glLightfv,GL_LIGHT6, GL_DIFFUSE

	mov	r8d,offset pos
	invoke	glLightfv,GL_LIGHT3, GL_POSITION
	mov	eax,const_3_0
	mov	pos[0*4],eax
	mov	r8d,offset pos
	invoke	glLightfv,GL_LIGHT5, GL_POSITION
	mov	pos[0*4],ebx
	mov	eax,const_3_0
	mov	pos[1*4],eax
	mov	r8d,offset pos
	invoke	glLightfv,GL_LIGHT6,GL_POSITION

	mov	r8d,offset mat_specular
	invoke	glMaterialfv,GL_FRONT,GL_SPECULAR
	movd	xmm2,const128_0
	invoke	glMaterialf,GL_FRONT,GL_SHININESS
        jmp	wmBYE
wmSIZE:;;     
	movzx	r8,r9w
	shr	r9,16
	invoke	glViewport,0,0
        jmp	wmBYE
wmPAINT:; No pending messages: draw the scene
;    z-
	invoke glClear,GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT
;   ( )
	invoke glLoadIdentity
;     (z=-3.5)
	movd	xmm2,const_3_5
	movd	xmm1,ebx
	movd	xmm0,ebx
	invoke glTranslatef
;----------------------------------------
	mov	rax,constd1_0
	movq	xmm0,rax; 
	movq	xmm1,rax; 
	movq	xmm2,rax; 
	invoke	glColor3d
        movq	xmm0,constd2_0
	invoke	glutSolidSphere,,32,32
;----------------------------------------
;   
        invoke	SwapBuffers,hDC
wmBYE:	leave
	xor	eax,eax
	retn	
WndProc	endp
hDC	dq	?
hrc	dq	?
PixFrm	label	PIXELFORMATDESCRIPTOR 
	nSize             dw	sizeof PIXELFORMATDESCRIPTOR;  
  	nVersion          dw	1;  
  	dwFlags           dd	PFD_SUPPORT_OPENGL or PFD_DOUBLEBUFFER or \
	PFD_DRAW_TO_WINDOW ;  ,     
  	iPixelType        db	PFD_TYPE_RGBA; RGBA 
  	cColorBits        db	32;   
  	cRedBits          db	0
  	cRedShift         db	0
  	cGreenBits        db	0
  	cGreenShift       db	0
  	cBlueBits         db	0
  	cBlueShift        db	0;  
  	cAlphaBits        db	0;  
  	cAlphaShift       db	0;  
  	cAccumBits        db	0;  
  	cAccumRedBits     db	0
  	cAccumGreenBits   db	0
  	cAccumBlueBits    db	0
  	cAccumAlphaBits   db	0;  
  	cDepthBits        db	32;32  Z- ( )
  	cStencilBits      db	0;  
  	cAuxBuffers       db	0;  
  	iLayerType        db	PFD_MAIN_PLANE;  
  	bReserved         db	0;
  	dwLayerMask       dd	0
  	dwVisibleMask     dd	0
  	dwDamageMask      dd	0;  
;double----------------------------
constd1_0	dq 1.0
constd0_1	dq 0.1
constd2_0	dq 2.0
constd90_0	dq 90.0
constd100_0	dq 100.0
ratio		dq 1.1
;float-------------------------------
const_3_0	dd -3.0
const_3_5	dd -3.5
const1_0	dd 1.0
const128_0	dd 128.0
;  
pos		dd 0.3,0.3,0.3,0.1
color		dd 1.0,1.0,1.0,1.0
sp_		dd 1.0,1.0,1.0,1.0
mat_specular	dd 1.0,1.0,1.0,1.0
szClassName	db "Uncle Remus tales:#40 OpenGL - Glaux Template",0
FileName	db "br_Rabbit3.cur",0

end